diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/utils/create-module.py ns-3.36/utils/create-module.py
--- ns-3.35/utils/create-module.py	2021-10-01 13:26:48.000000000 -0700
+++ ns-3.36/utils/create-module.py	2022-04-30 18:23:58.234735300 -0700
@@ -7,47 +7,33 @@
 
 from pathlib import Path
 
-WSCRIPT_TEMPLATE = '''# -*- Mode: python; py-indent-offset: 4; indent-tabs-mode: nil; coding: utf-8; -*-
-
-# def options(opt):
-#     pass
-
-# def configure(conf):
-#     conf.check_nonfatal(header_name='stdint.h', define_name='HAVE_STDINT_H')
-
-def build(bld):
-    module = bld.create_ns3_module({MODULE!r}, ['core'])
-    module.source = [
-        'model/{MODULE}.cc',
-        'helper/{MODULE}-helper.cc',
-        ]
-
-    module_test = bld.create_ns3_module_test_library('{MODULE}')
-    module_test.source = [
-        'test/{MODULE}-test-suite.cc',
-        ]
-    # Tests encapsulating example programs should be listed here
-    if (bld.env['ENABLE_EXAMPLES']):
-        module_test.source.extend([
-        #    'test/{MODULE}-examples-test-suite.cc',
-             ])
-
-    headers = bld(features='ns3header')
-    headers.module = {MODULE!r}
-    headers.source = [
-        'model/{MODULE}.h',
-        'helper/{MODULE}-helper.h',
-        ]
-
-    if bld.env.ENABLE_EXAMPLES:
-        bld.recurse('examples')
-
-    # bld.ns3_python_bindings()
-
+CMAKELISTS_TEMPLATE = '''\
+check_include_file_cxx(stdint.h HAVE_STDINT_H)
+if(HAVE_STDINT_H)
+    add_definitions(-DHAVE_STDINT_H)
+endif()
+
+set(examples_as_tests_sources)
+if(${{ENABLE_EXAMPLES}})
+    set(examples_as_tests_sources    
+        #test/{MODULE}-examples-test-suite.cc
+        )
+endif()    
+
+build_lib(
+    LIBNAME {MODULE}
+    SOURCE_FILES model/{MODULE}.cc
+                 helper/{MODULE}-helper.cc 
+    HEADER_FILES model/{MODULE}.h
+                 helper/{MODULE}-helper.h
+    LIBRARIES_TO_LINK ${{libcore}}
+    TEST_SOURCES test/{MODULE}-test-suite.cc
+                 ${{examples_as_tests_sources}}
+)
+    
 '''
 
 
-
 MODEL_CC_TEMPLATE = '''/* -*- Mode:C++; c-file-style:"gnu"; indent-tabs-mode:nil; -*- */
 
 #include "{MODULE}.h"
@@ -111,11 +97,12 @@
 '''
 
 
-EXAMPLES_WSCRIPT_TEMPLATE = '''# -*- Mode: python; py-indent-offset: 4; indent-tabs-mode: nil; coding: utf-8; -*-
-
-def build(bld):
-    obj = bld.create_ns3_program('{MODULE}-example', [{MODULE!r}])
-    obj.source = '{MODULE}-example.cc'
+EXAMPLES_CMAKELISTS_TEMPLATE = '''\
+build_lib_example(
+    NAME {MODULE}-example
+    SOURCE_FILES {MODULE}-example.cc
+    LIBRARIES_TO_LINK ${{lib{MODULE}}}
+)
 
 '''
 
@@ -326,12 +313,15 @@
     with artifact_path.open("wt") as f:
         f.write(template.format(**kwargs))
 
-def make_wscript(moduledir, modname):
-    path = Path(moduledir, 'wscript')
-    create_file(path, WSCRIPT_TEMPLATE, MODULE=modname)
+
+def make_cmakelists(moduledir, modname):
+    path = Path(moduledir, 'CMakeLists.txt')
+    macro = "build_lib"
+    create_file(path, CMAKELISTS_TEMPLATE, MODULE=modname)
 
     return True 
 
+
 def make_model(moduledir, modname):
     modelpath = Path(moduledir, "model")
     modelpath.mkdir(parents=True)
@@ -379,8 +369,8 @@
     examplespath = Path(moduledir, "examples")
     examplespath.mkdir(parents=True)
 
-    wscriptpath = Path(examplespath, 'wscript')
-    create_file(wscriptpath, EXAMPLES_WSCRIPT_TEMPLATE, MODULE=modname)
+    cmakelistspath = Path(examplespath, 'CMakeLists.txt')
+    create_file(cmakelistspath, EXAMPLES_CMAKELISTS_TEMPLATE, MODULE=modname)
 
     examplesfile_path = examplespath.joinpath(modname+'-example').with_suffix('.cc')
     create_file(examplesfile_path, EXAMPLE_CC_TEMPLATE, MODULE=modname)
@@ -398,11 +388,11 @@
 
     file_name = '{}.rst'.format(modname)
     file_path = Path(docpath, file_name)
-    create_file(file_path, DOC_RST_TEMPLATE, MODULE=modname,
-                MODULE_DIR=mod_relpath)
+    create_file(file_path, DOC_RST_TEMPLATE, MODULE=modname, MODULE_DIR=mod_relpath)
 
     return True 
 
+
 def make_module(modpath, modname):
     modulepath = Path(modpath, modname)
 
@@ -412,7 +402,7 @@
 
     print("Creating module {}".format(modulepath))
 
-    functions = (make_wscript, make_model, make_test, 
+    functions = (make_cmakelists, make_model, make_test,
                  make_helper, make_examples, make_doc)
 
     try:
@@ -438,17 +428,17 @@
 
 Generates the directory structure and skeleton files required for an ns-3
 module.  All of the generated files are valid C/C++ and will compile successfully
-out of the box.  waf configure must be run after creating new modules in order
+out of the box.  ns3 configure must be run after creating new modules in order
 to integrate them into the ns-3 build system.
 
 The following directory structure is generated under the contrib directory:
 <modname>
- |-- wscript
+ |-- CMakeLists.txt
  |-- doc
      |-- <modname>.rst
  |-- examples
      |-- <modname>-example.cc
-     |-- wscript
+     |-- CMakeLists.txt
  |-- helper
      |-- <modname>-helper.cc
      |-- <modname>-helper.h
@@ -622,7 +612,7 @@
     if all(make_module(*module) for module in modules):
         print()
         print("Successfully created new modules")
-        print("Run './waf configure' to include them in the build")
+        print("Run './ns3 configure' to include them in the build")
         
     return 0
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/utils/grid.py ns-3.36/utils/grid.py
--- ns-3.35/utils/grid.py	2021-10-01 13:26:48.000000000 -0700
+++ ns-3.36/utils/grid.py	2022-04-30 18:23:58.234735300 -0700
@@ -21,7 +21,6 @@
         @param start start
         @param end end
         @param value value
-        @return none
         """
         self.start = start
         self.end = end
@@ -37,7 +36,6 @@
         @param self this object
         @param at you
         @param value value
-        @return none
         """
         self.at = at
         self.value = value
@@ -52,7 +50,6 @@
         @param self this object
         @param at you
         @param value value
-        @return none
         """
         self.at = at
         self.value = value
@@ -67,7 +64,6 @@
         @param self this object
         @param at you
         @param value value
-        @return none
         """
         self.at = at
         self.value = value
@@ -97,7 +93,6 @@
         """! Initializer
         @param self this object
         @param name name
-        @return none
         """
         self.name = name
         self.ranges = []
@@ -194,7 +189,6 @@
         """! Get ranges bounds
         @param self this object
         @param name name
-        @return none
         """
         self.name = name
         self.events = []
@@ -275,7 +269,6 @@
         """! Initializer
         @param self this object
         @param name name
-        @return none
         """
         self.ranges = []
         self.event_str = []
@@ -447,7 +440,6 @@
         @param r: red
         @param g: green
         @param b: blue
-        @return none
         """
         self.r = r
         self.g = g
@@ -475,7 +467,6 @@
     def __init__(self):
         """! Initializer
         @param self this object
-        @return none
         """
         self.__colors = {}
     def add(self, name, color):
@@ -511,7 +502,6 @@
     def __init__(self):
         """! Initializer
         @param self this object
-        @return none
         """
         self.__padding = 10
     def set_padding(self, padding):
@@ -627,7 +617,6 @@
     def __init__(self):
         """! Initializer
         @param self this object
-        @return none
         """
         self.padding = 10
         return
@@ -863,7 +852,6 @@
     def __init__(self):
         """! Initializer
         @param self this object
-        @return none
         """
         self.__top = 0
         return
@@ -1007,7 +995,6 @@
         @param self this object
         @param start start
         @param end end
-        @return none
         """
         self.__start = float(start)
         self.__end = float(end)
@@ -1301,7 +1288,6 @@
         """! Initializer
         @param self this object
         @param data data
-        @return none
         """
         super(GtkGraphicRenderer, self).__init__()
         self.__data = data
@@ -1542,7 +1528,6 @@
     def __init__(self):
         """! Initializer
         @param self this object
-        @return none
         """
         return
     def run(self, graphic):
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/utils/perf/perf-io.cc ns-3.36/utils/perf/perf-io.cc
--- ns-3.35/utils/perf/perf-io.cc	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.36/utils/perf/perf-io.cc	2022-04-30 18:23:58.234735300 -0700
@@ -0,0 +1,146 @@
+/* -*- Mode:C++; c-file-style:"gnu"; indent-tabs-mode:nil; -*- */
+/*
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation;
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ */
+
+#include <chrono>
+
+#include <cstdio>
+#include <cstdlib>
+
+#include <iostream>
+#include <fstream>
+
+#include "ns3/core-module.h"
+
+using namespace ns3;
+
+/**
+ * \ingroup system-tests-perf
+ * 
+ * Check the performance of writing to file.
+ * 
+ * \param file The file to write to.
+ * \param n The number of writes to perform.
+ * \param buffer The buffer to write.
+ * \param size The buffer size.
+ */
+void
+PerfFile (FILE *file, uint32_t n, const char *buffer, uint32_t size)
+{
+  for (uint32_t i = 0; i < n; ++i)
+    {
+      if (std::fwrite (buffer, 1, size, file) !=  size)
+        {
+          NS_ABORT_MSG ("PerfFile():  fwrite error");
+        }
+    }
+}
+
+/**
+ * \ingroup system-tests-perf
+ * 
+ * Check the performance of writing to an output stream.
+ * 
+ * \param stream The output stream to write to.
+ * \param n The number of writes to perform.
+ * \param buffer The buffer to write.
+ * \param size The buffer size.
+ */
+void
+PerfStream (std::ostream &stream, uint32_t n, const char *buffer, uint32_t size)
+{
+  for (uint32_t i = 0; i < n; ++i)
+    {
+      stream.write (buffer, size);
+    }
+}
+
+int 
+main (int argc, char *argv[])
+{
+  uint32_t n = 100000;
+  uint32_t iter = 50;
+  bool doStream = false;
+  bool binmode = true;
+
+  CommandLine cmd (__FILE__);
+  cmd.AddValue ("n", "How many times to write (defaults to 100000", n);
+  cmd.AddValue ("iter", "How many times to run the test looking for a min (defaults to 50)", iter);
+  cmd.AddValue ("doStream", "Run the C++ I/O benchmark otherwise the C I/O ", doStream);
+  cmd.AddValue ("binmode", "Select binary mode for the C++ I/O benchmark (defaults to true)", binmode);
+  cmd.Parse (argc, argv);
+
+  auto minResultNs = std::chrono::duration_cast<std::chrono::nanoseconds> (
+    std::chrono::nanoseconds::max ());
+
+  char buffer[1024];
+
+  if (doStream)
+    {
+      //
+      // This will probably run on a machine doing other things.  Run it some
+      // relatively large number of times and try to find a minimum, which
+      // will hopefully represent a time when it runs free of interference.
+      //
+      for (uint32_t i = 0; i < iter; ++i)
+        {
+          std::ofstream stream;
+          if (binmode)
+            {
+              stream.open ("streamtest", std::ios_base::binary | std::ios_base::out);
+            }
+          else
+            {
+              stream.open ("streamtest", std::ios_base::out);
+            }
+
+          auto start = std::chrono::steady_clock::now ();
+          PerfStream (stream, n, buffer, 1024);
+          auto end = std::chrono::steady_clock::now ();
+          auto resultNs = std::chrono::duration_cast<std::chrono::nanoseconds> (end - start);
+          resultNs = std::min (resultNs, minResultNs);
+          stream.close ();
+          std::cout << "."; std::cout.flush ();
+        }
+
+      std::cout << std::endl;
+    }
+  else
+    {
+      //
+      // This will probably run on a machine doing other things.  Run it some
+      // relatively large number of times and try to find a minimum, which
+      // will hopefully represent a time when it runs free of interference.
+      //
+      for (uint32_t i = 0; i < iter; ++i)
+        {
+          FILE *file = fopen ("filetest", "w");
+
+          auto start = std::chrono::steady_clock::now ();
+          PerfFile (file, n, buffer, 1024);
+          auto end = std::chrono::steady_clock::now ();
+          auto resultNs = std::chrono::duration_cast<std::chrono::nanoseconds> (end - start);
+          resultNs = std::min (resultNs, minResultNs);
+          fclose (file);
+          file = 0;
+          std::cout << "."; std::cout.flush ();
+        }
+      std::cout << std::endl;
+    }
+
+  std::cout << argv[0] << ": " << minResultNs.count () << "ns" << std::endl;
+
+  return 0;
+}
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/utils/print-introspected-doxygen.cc ns-3.36/utils/print-introspected-doxygen.cc
--- ns-3.35/utils/print-introspected-doxygen.cc	2021-10-01 13:26:48.000000000 -0700
+++ ns-3.36/utils/print-introspected-doxygen.cc	2022-04-30 18:23:58.234735300 -0700
@@ -1052,8 +1052,8 @@
   NS_LOG_FUNCTION_NOARGS ();
   os << commentStart << page << "AttributeList All Attributes\n"
      << std::endl;
-  os << "This is a list of all" << reference << "ns3::Attributes by class.  "
-     << "For more information see the" << reference << "ns3:Attributes "
+  os << "This is a list of all" << reference << "attributes classes.  "
+     << "For more information see the" << reference << "attributes "
      << "section of this API documentation and the Attributes sections "
      << "in the Tutorial and Manual.\n"
      << std::endl;
@@ -1263,7 +1263,7 @@
  *
  * In doxygen form this will print a comment block with
  * \verbatim
- *   \ingroup attribute
+ *   \ingroup attributes
  *   \defgroup attribute_<name>Value <name>Value
  * \endverbatim
  *
@@ -1279,12 +1279,12 @@
   NS_LOG_FUNCTION (name);
   std::string section = "attribute_" + name;
 
-  // \ingroup attribute
+  // \ingroup attributes
   // \defgroup attribute_<name>Value <name> Attribute
-  os << commentStart << sectionStart << "attribute\n"
+  os << commentStart << sectionStart << "attributes\n"
      <<   subSectionStart << "attribute_" << name << " "
      <<     name << " Attribute\n"
-     <<     "Attribute implementation for " << name << "\n";
+     <<     "AttributeValue implementation for " << name << "\n";
   if (seeBase)
     {
       // Some classes don't live in ns3::.  Yuck
@@ -1524,11 +1524,13 @@
       { "OrganizationIdentifier",
                           "OrganizationIdentifier",
                                             true,  "vendor-specific-action.h" },
+      { "Priomap",        "Priomap",        true,  "prio-queue-disc.h"  },
+      { "QueueSize",      "QueueSize",      true,  "queue-size.h"       },
       { "Rectangle",      "Rectangle",      true,  "rectangle.h"        },
       { "Ssid",           "Ssid",           true,  "ssid.h"             },
       { "TypeId",         "TypeId",         true,  "type-id.h"          },
       { "UanModesList",   "UanModesList",   true,  "uan-tx-mode.h"      },
-      // { "ValueClassTest", "ValueClassTest", false, "" /* outside ns3 */ },
+      { "ValueClassTest", "ValueClassTest", false, "attribute-test-suite.cc" /* core/test/ */  },
       { "Vector",         "Vector",         true,  "vector.h"           },
       { "Vector2D",       "Vector2D",       true,  "vector.h"           },
       { "Vector3D",       "Vector3D",       true,  "vector.h"           },
@@ -1576,8 +1578,13 @@
   PrintAttributeValueWithName (os, "Pair", "std::pair<A, B>", "pair.h");
   PrintMakeChecker            (os, "Pair",  "pair.h");
   
-  PrintAttributeValueSection  (os, "AttributeContainer", false);
-  PrintAttributeValueWithName (os, "AttributeContainer", "AttributeContainer", "attribute-container.h");
+  PrintAttributeValueSection  (os, "Tuple", false);
+  PrintAttributeValueWithName (os, "Tuple", "std::tuple<Args...>", "tuple.h");
+  PrintMakeChecker            (os, "Tuple", "tuple.h");
+
+  // AttributeContainer is already documented.
+  // PrintAttributeValueSection  (os, "AttributeContainer", false);
+  // PrintAttributeValueWithName (os, "AttributeContainer", "AttributeContainer", "attribute-container.h");
   PrintMakeChecker            (os, "AttributeContainer",  "attribute-container.h");
 }  // PrintAttributeImplementations ()
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/utils/python-unit-tests.py ns-3.36/utils/python-unit-tests.py
--- ns-3.35/utils/python-unit-tests.py	2021-10-01 13:26:48.000000000 -0700
+++ ns-3.36/utils/python-unit-tests.py	2022-04-30 18:23:58.234735300 -0700
@@ -1,3 +1,5 @@
+#! /usr/bin/env python3
+
 # Copyright (C) 2008-2011 INESC Porto
 
 # This program is free software; you can redistribute it and/or modify
@@ -25,6 +27,8 @@
 import ns.csma
 import ns.applications
 
+UINT32_MAX = 0xFFFFFFFF
+
 
 ## TestSimulator class
 class TestSimulator(unittest.TestCase):
@@ -170,7 +174,7 @@
             @return none
             """
             assert self._received_packet is None
-            self._received_packet = socket.Recv()
+            self._received_packet = socket.Recv(maxSize=UINT32_MAX, flags=0)
 
         sink = ns.network.Socket.CreateSocket(node, ns.core.TypeId.LookupByName("ns3::UdpSocketFactory"))
         sink.Bind(ns.network.InetSocketAddress(ns.network.Ipv4Address.GetAny(), 80))
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/utils/run-examples-with-full-logging.sh ns-3.36/utils/run-examples-with-full-logging.sh
--- ns-3.35/utils/run-examples-with-full-logging.sh	2021-10-01 13:26:48.000000000 -0700
+++ ns-3.36/utils/run-examples-with-full-logging.sh	2022-04-30 18:23:58.234735300 -0700
@@ -33,7 +33,7 @@
   if [[ "$line" == example* ]]
     then
       name=${line#example      }
-      NS_LOG="*" ./waf --run "$name" >& /dev/null
+      NS_LOG="*" ./ns3 --run "$name" >& /dev/null
       status="$?"
       echo "program $name status $status"
   fi
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/utils/tests/TestBase.py ns-3.36/utils/tests/TestBase.py
--- ns-3.35/utils/tests/TestBase.py	2021-10-01 13:26:48.000000000 -0700
+++ ns-3.36/utils/tests/TestBase.py	2022-04-30 18:23:58.234735300 -0700
@@ -42,7 +42,7 @@
 
 def set_workdir():
     dir_files = [ f for f in os.listdir('.') if os.path.exists(f) ]
-    if not 'VERSION' in dir_files and not 'waf' in dir_files:
+    if not 'VERSION' in dir_files and not 'ns3' in dir_files:
         if os.path.split(os.path.abspath('.'))[1] == 'tests' and os.path.split(os.path.abspath(os.pardir))[1] == 'utils':
                 os.chdir('../../')
         else:
@@ -70,7 +70,6 @@
         @param argv argument list
         @param desc description
         @param mode test mode
-        @return none
         """
         self.my_env = os.environ
         set_workdir()
